"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.schemaSettingsPropertyCompletionItems = void 0;
const vscode_json_languageservice_1 = require("vscode-json-languageservice");
const translations_1 = require("../../../../translations");
function schemaSettingsPropertyCompletionItems(parsedSchema, translations) {
    return parsedSchema.settings
        .filter((setting) => setting.id)
        .map((setting) => {
        let docValue = '';
        if (setting.label) {
            if (setting.label.startsWith('t:')) {
                const translation = (0, translations_1.translationValue)(setting.label.substring(2), translations);
                if (translation) {
                    docValue = (0, translations_1.renderTranslation)(translation);
                }
            }
            else {
                docValue = setting.label;
            }
        }
        const completionText = setting.id ? `"${setting.id}"` : '';
        return {
            kind: vscode_json_languageservice_1.CompletionItemKind.Property,
            label: completionText,
            insertText: completionText,
            documentation: {
                kind: vscode_json_languageservice_1.MarkupKind.Markdown,
                value: docValue,
            },
        };
    });
}
exports.schemaSettingsPropertyCompletionItems = schemaSettingsPropertyCompletionItems;
//# sourceMappingURL=schemaSettings.js.map